<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>alighsw_lib.py</title>
  <link rel="stylesheet" href="pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>alighsw_lib.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      <p>Program which recreates the local Smith Waterman alignment.
Currently we support the following 5 functions:</p>
<ol>
<li><strong>Get_similarity</strong> - Returns if two letters are equal</li>
<li><strong>Get_score</strong> - Return  score</li>
<li><strong>Traceback</strong> - Get the alignment of the sequences</li>
<li><strong>Create_matrix</strong> - Create matrix of alignment</li>
<li><strong>Smith_waterman_algorithm</strong> - Call the others functions</li>
</ol>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      <h3><span id="get_similarity" href="get_similarity"> Get_similarity </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_similarity</span><span class="p">(</span><span class="n">a_letter</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">b_letter</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">match</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <p>Returns if two letters are equal</p>
<p>Arguments:</p>
<p>a_letter {str} &ndash; first letter</p>
<p>b_letter {str} &ndash; second letter</p>
<p>match {int} &ndash; the punctuation if the letters are the same</p>
<p>Returns:</p>
<p>[int] &ndash; the punctuation</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">a_letter</span> <span class="o">==</span> <span class="n">b_letter</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">match</span>
    <span class="k">return</span> <span class="o">-</span><span class="n">match</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <h3><span id="get_score" href="get_score"> Get_score </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_score</span><span class="p">(</span><span class="n">adn1</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">adn2</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">matriz</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      <p>Give the matrix score</p>
<p>Arguments:</p>
<p>adn1 {str} &ndash; sequence one</p>
<p>adn2 {str} &ndash; sequence two</p>
<p>matriz {np.ndarray} &ndash; matrix</p>
<p>Returns:</p>
<p>[tuple] &ndash; position</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">seq1</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">adn1</span><span class="p">)</span> <span class="o">+</span> <span class="mi">1</span>
    <span class="n">seq2</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">adn2</span><span class="p">)</span> <span class="o">+</span> <span class="mi">1</span>
    <span class="nb">max</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">position</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">seq1</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">seq2</span><span class="p">):</span>
            <span class="k">if</span> <span class="nb">max</span> <span class="o">&lt;</span> <span class="n">matriz</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="n">j</span><span class="p">]:</span>
                <span class="nb">max</span> <span class="o">=</span> <span class="n">matriz</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="n">j</span><span class="p">]</span>
                <span class="n">position</span> <span class="o">=</span> <span class="p">(</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">),</span> <span class="nb">str</span><span class="p">(</span><span class="n">j</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">position</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      <h3><span id="traceback" href="traceback"> Traceback </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">traceback</span><span class="p">(</span><span class="n">adn1</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">adn2</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="nb">max</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">matriz</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">match</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">gap</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <p>Get the alignment of the sequences</p>
<p>Arguments:</p>
<p>adn1 {str} &ndash; sequence one</p>
<p>adn2 {str} &ndash; sequence two</p>
<p>max {str} &ndash;  position max</p>
<p>matriz {np.ndarray} &ndash; matrix</p>
<p>match {int} &ndash; punctuation if there is match</p>
<p>gap {int} &ndash; punctuation if there is a gap</p>
<p>Returns:</p>
<p>[list] &ndash; alignment of the sequences</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">aligment_a</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">aligment_a_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">aligment_b</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">aligment_b_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">aligment_c</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">aligment_c_list</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="n">i</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">max</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">j</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">max</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
    <span class="k">while</span><span class="p">(</span><span class="n">i</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">j</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
        <span class="n">similarity</span> <span class="o">=</span> <span class="n">get_similarity</span><span class="p">(</span><span class="n">adn1</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">adn2</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">match</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">i</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">j</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">matriz</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="n">j</span><span class="p">]</span> <span class="o">==</span> <span class="n">matriz</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">][</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">similarity</span><span class="p">:</span>
            <span class="n">aligment_a</span> <span class="o">+=</span> <span class="n">adn1</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">aligment_a_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">adn1</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
            <span class="n">aligment_b</span> <span class="o">+=</span> <span class="n">adn2</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">aligment_b_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">adn2</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
            <span class="n">aligment_c</span> <span class="o">+=</span> <span class="s2">&quot;|&quot;</span>
            <span class="n">aligment_c_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;|&quot;</span><span class="p">)</span>

            <span class="n">i</span> <span class="o">=</span> <span class="n">i</span><span class="o">-</span><span class="mi">1</span>
            <span class="n">j</span> <span class="o">=</span> <span class="n">j</span><span class="o">-</span><span class="mi">1</span>
        <span class="k">elif</span><span class="p">(</span><span class="n">i</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">matriz</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="n">j</span><span class="p">]</span> <span class="o">==</span> <span class="n">matriz</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">][</span><span class="n">j</span><span class="p">]</span><span class="o">+</span><span class="p">(</span><span class="o">-</span><span class="n">gap</span><span class="p">)):</span>
            <span class="n">aligment_a</span> <span class="o">+=</span> <span class="n">adn1</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">aligment_a_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">adn1</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
            <span class="n">aligment_b</span> <span class="o">+=</span> <span class="s2">&quot;-&quot;</span>
            <span class="n">aligment_b_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;-&quot;</span><span class="p">)</span>
            <span class="n">aligment_c</span> <span class="o">+=</span> <span class="s2">&quot; &quot;</span>
            <span class="n">aligment_c_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">)</span>
            <span class="n">i</span> <span class="o">=</span> <span class="n">i</span><span class="o">-</span><span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">aligment_a</span> <span class="o">+=</span> <span class="s2">&quot;-&quot;</span>
            <span class="n">aligment_a_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;-&quot;</span><span class="p">)</span>
            <span class="n">aligment_b</span> <span class="o">+=</span> <span class="n">adn2</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">aligment_b_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">adn2</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>
            <span class="n">aligment_c</span> <span class="o">+=</span> <span class="s2">&quot; &quot;</span>
            <span class="n">aligment_c_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot; &quot;</span><span class="p">)</span>

            <span class="n">j</span> <span class="o">=</span> <span class="n">j</span><span class="o">-</span><span class="mi">1</span>

    <span class="n">result</span> <span class="o">=</span> <span class="p">[</span><span class="n">aligment_a_list</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span>
              <span class="n">aligment_c_list</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">aligment_b_list</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]]</span>
    <span class="k">return</span> <span class="n">result</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <h3><span id="create_matrix" href="create_matrix"> Create_matrix </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">create_matrix</span><span class="p">(</span><span class="n">adn1</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">adn2</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">match</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">gap</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-8'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-8'>#</a>
      </div>
      <p>Create matrix</p>
<p>Arguments:</p>
<p>adn1 {str} &ndash; sequence one</p>
<p>adn2 {str} &ndash; sequence two</p>
<p>match {int} &ndash; punctuation if there is match</p>
<p>gap {int} &ndash; punctuation if there is a gap</p>
<p>Returns:</p>
<p>[np.ndarray] &ndash; matrix of alignment</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">len_adn1</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">adn1</span><span class="p">)</span>
    <span class="n">len_adn2</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">adn2</span><span class="p">)</span>
    <span class="n">mat</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">((</span><span class="n">len_adn1</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="n">len_adn2</span><span class="o">+</span><span class="mi">1</span><span class="p">),</span> <span class="nb">int</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">len_adn1</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">len_adn2</span><span class="p">):</span>
            <span class="n">diagonal</span> <span class="o">=</span> <span class="n">mat</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="n">j</span><span class="p">]</span>
            <span class="n">abajo</span> <span class="o">=</span> <span class="n">mat</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">][</span><span class="n">j</span><span class="p">]</span>
            <span class="n">derecha</span> <span class="o">=</span> <span class="n">mat</span><span class="p">[</span><span class="n">i</span><span class="p">][</span><span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">adn1</span><span class="p">[</span><span class="n">i</span><span class="p">]</span> <span class="o">==</span> <span class="n">adn2</span><span class="p">[</span><span class="n">j</span><span class="p">]:</span>
                <span class="n">mat</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">][</span><span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">diagonal</span><span class="o">+</span><span class="n">match</span><span class="p">,</span> <span class="n">abajo</span><span class="o">-</span><span class="n">gap</span><span class="p">,</span> <span class="n">derecha</span><span class="o">-</span><span class="n">gap</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">mat</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">][</span><span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">diagonal</span><span class="o">-</span><span class="n">match</span><span class="p">,</span> <span class="n">abajo</span><span class="o">-</span><span class="n">gap</span><span class="p">,</span> <span class="n">derecha</span><span class="o">-</span><span class="n">gap</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">mat</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-9'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-9'>#</a>
      </div>
      <h3><span id="smith_waterman_algorithm" href="smith_waterman_algorithm"> Smith_waterman_algorithm </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">smith_waterman_algorithm</span><span class="p">(</span><span class="n">adn1</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">adn2</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">match</span><span class="p">:</span> <span class="nb">int</span><span class="p">,</span> <span class="n">gap</span><span class="p">:</span> <span class="nb">int</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-10'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-10'>#</a>
      </div>
      <p>Call the others functions</p>
<p>Arguments:</p>
<p>adn1 {str} &ndash; sequence one</p>
<p>adn2 {str} &ndash; sequence two</p>
<p>match {int} &ndash; punctuation if there is match</p>
<p>gap {int} &ndash;  punctuation if there is gap</p>
<p>Returns:</p>
<p>[list] &ndash; Content the others functions</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">adn1</span> <span class="o">=</span> <span class="n">adn1</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span>
    <span class="n">adn2</span> <span class="o">=</span> <span class="n">adn2</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span>
    <span class="n">matriz</span> <span class="o">=</span> <span class="n">create_matrix</span><span class="p">(</span><span class="n">adn1</span><span class="p">,</span> <span class="n">adn2</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">2</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">get_score</span><span class="p">(</span><span class="n">adn1</span><span class="p">,</span> <span class="n">adn2</span><span class="p">,</span> <span class="n">matriz</span><span class="p">)</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span><span class="p">:</span>
        <span class="n">result</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;There is no similarity.&quot;</span><span class="p">]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">postion_max</span> <span class="o">=</span> <span class="n">get_score</span><span class="p">(</span><span class="n">adn1</span><span class="p">,</span> <span class="n">adn2</span><span class="p">,</span> <span class="n">matriz</span><span class="p">)</span>

        <span class="n">traceback</span><span class="p">(</span><span class="n">adn1</span><span class="p">,</span> <span class="n">adn2</span><span class="p">,</span> <span class="n">postion_max</span><span class="p">,</span> <span class="n">matriz</span><span class="p">,</span> <span class="n">match</span><span class="p">,</span> <span class="n">gap</span><span class="p">)</span>

        <span class="n">result</span> <span class="o">=</span> <span class="p">[</span><span class="n">adn1</span><span class="p">,</span> <span class="n">adn2</span><span class="p">,</span> <span class="n">traceback</span><span class="p">(</span>
            <span class="n">adn1</span><span class="p">,</span> <span class="n">adn2</span><span class="p">,</span> <span class="n">postion_max</span><span class="p">,</span> <span class="n">matriz</span><span class="p">,</span> <span class="n">match</span><span class="p">,</span> <span class="n">gap</span><span class="p">),</span> <span class="n">matriz</span><span class="p">]</span>

    <span class="k">return</span> <span class="n">result</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
